/////////////////////////////////////////////////////////////////////////
// $Id: stack16.cc,v 1.13 2002/09/20 23:17:51 kevinlawton Exp $
/////////////////////////////////////////////////////////////////////////
//
//  Copyright (C) 2001  MandrakeSoft S.A.
//
//    MandrakeSoft S.A.
//    43, rue d'Aboukir
//    75002 Paris - France
//    http://www.linux-mandrake.com/
//    http://www.mandrakesoft.com/
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2 of the License, or (at your option) any later version.
//
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA








#define NEED_CPU_REG_SHORTCUTS 1
#include "bochs.h"
#define LOG_THIS BX_CPU_THIS_PTR


  void
BX_CPU_C::PUSH_RX(bxInstruction_c *i)
{
  Expression *Expr16[2];
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
	Expr16[0] = MakeACopyOf(TheLabels.ReadSymbolicRegister(i->opcodeReg(), 0));
	Expr16[1] = MakeACopyOf(TheLabels.ReadSymbolicRegister(i->opcodeReg(), 1));
  }
#endif
  push_16( BX_CPU_THIS_PTR gen_reg[i->opcodeReg()].word.rx, BX_CPU_THIS_PTR gen_reg[i->opcodeReg()].reg_integrity, &(Expr16[0]));
}

  void
BX_CPU_C::POP_RX(bxInstruction_c *i)
{
  Bit16u rx;
  Bit8u rx_integrity;
  Expression *Expr16[2];

  pop_16(&rx, &rx_integrity, &(Expr16[0]));
  BX_CPU_THIS_PTR gen_reg[i->opcodeReg()].word.rx = rx;
  //BX_CPU_THIS_PTR gen_reg[i->opcodeReg()].reg_integrity = rx_integrity;
  BX_WRITE_16BIT_REG_INTEGRITY(i->opcodeReg(), rx_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
	TheLabels.WriteSymbolicRegister(i->opcodeReg(), 0, MakeACopyOf(Expr16[0]));
	TheLabels.WriteSymbolicRegister(i->opcodeReg(), 1, MakeACopyOf(Expr16[1]));
  }
#endif
}

  void
BX_CPU_C::POP_Ew(bxInstruction_c *i)
{
  Bit16u val16;
  Bit8u val16_integrity;
  Expression *Expr16[2];

  pop_16(&val16, &val16_integrity, &(Expr16[0]));

  if (i->modC0()) {
    BX_WRITE_16BIT_REG(i->rm(), val16);
    BX_WRITE_16BIT_REG_INTEGRITY(i->rm(), val16_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
	TheLabels.WriteSymbolicRegister(i->rm(), 0, MakeACopyOf(Expr16[0]));
	TheLabels.WriteSymbolicRegister(i->rm(), 1, MakeACopyOf(Expr16[1]));
  }
#endif
    }
  else {
    // Note: there is one little weirdism here.  When 32bit addressing
    // is used, it is possible to use ESP in the modrm addressing.
    // If used, the value of ESP after the pop is used to calculate
    // the address.
    if (i->as32L() && (!i->modC0()) && (i->rm()==4) && (i->sibBase()==4)) {
      BX_CPU_CALL_METHOD (i->ResolveModrm, (i));
      }
    write_virtual_word(i->seg(), RMAddr(i), &val16, &val16_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	write_virtual_expression(i->seg(), RMAddr(i), MakeACopyOf(Expr16[0]));
  	write_virtual_expression(i->seg(), RMAddr(i) + 1, MakeACopyOf(Expr16[1]));
  }
#endif
    }
}

  void
BX_CPU_C::PUSHAD16(bxInstruction_c *i)
{
#if BX_CPU_LEVEL < 2
  BX_PANIC(("PUSHAD: not supported on an 8086"));
#else
  Bit32u temp_ESP;
  Bit16u sp;
  Expression *EAXExpr[2], *ECXExpr[2], *EDXExpr[2], *EBXExpr[2];
  Expression *ESPExpr[2], *EBPExpr[2], *ESIExpr[2], *EDIExpr[2];

  if (BX_CPU_THIS_PTR sregs[BX_SEG_REG_SS].cache.u.segment.d_b)
    temp_ESP = ESP;
  else
    temp_ESP = SP;


#if BX_CPU_LEVEL >= 2
    if (protected_mode()) {
      if ( !can_push(&BX_CPU_THIS_PTR sregs[BX_SEG_REG_SS].cache, temp_ESP, 16) ) {
        BX_PANIC(("PUSHA(): stack doesn't have enough room!"));
        exception(BX_SS_EXCEPTION, 0, 0);
        return;
        }
      }
    else
#endif
      {
      if (temp_ESP < 16)
        BX_PANIC(("pushad: eSP < 16"));
      }

    sp = SP;
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
	EAXExpr[0] = MakeACopyOf(TheLabels.ReadSymbolicRegister(0, 0));
	EAXExpr[1] = MakeACopyOf(TheLabels.ReadSymbolicRegister(0, 1));
	ECXExpr[0] = MakeACopyOf(TheLabels.ReadSymbolicRegister(1, 0));
	ECXExpr[1] = MakeACopyOf(TheLabels.ReadSymbolicRegister(1, 1));
	EDXExpr[0] = MakeACopyOf(TheLabels.ReadSymbolicRegister(2, 0));
	EDXExpr[1] = MakeACopyOf(TheLabels.ReadSymbolicRegister(2, 1));
	EBXExpr[0] = MakeACopyOf(TheLabels.ReadSymbolicRegister(3, 0));
	EBXExpr[1] = MakeACopyOf(TheLabels.ReadSymbolicRegister(3, 1));
	ESPExpr[0] = MakeACopyOf(TheLabels.ReadSymbolicRegister(4, 0));
	ESPExpr[1] = MakeACopyOf(TheLabels.ReadSymbolicRegister(4, 1));
	EBPExpr[0] = MakeACopyOf(TheLabels.ReadSymbolicRegister(5, 0));
	EBPExpr[1] = MakeACopyOf(TheLabels.ReadSymbolicRegister(5, 1));
	ESIExpr[0] = MakeACopyOf(TheLabels.ReadSymbolicRegister(6, 0));
	ESIExpr[1] = MakeACopyOf(TheLabels.ReadSymbolicRegister(6, 1));
	EDIExpr[0] = MakeACopyOf(TheLabels.ReadSymbolicRegister(7, 0));
	EDIExpr[1] = MakeACopyOf(TheLabels.ReadSymbolicRegister(7, 1));
  }
#endif

    /* ??? optimize this by using virtual write, all checks passed */
    push_16(AX, EAX_INTEGRITY, &(EAXExpr[0]));
    push_16(CX, ECX_INTEGRITY, &(ECXExpr[0]));
    push_16(DX, EDX_INTEGRITY, &(EDXExpr[0]));
    push_16(BX, EBX_INTEGRITY, &(EBXExpr[0]));
    push_16(sp, ESP_INTEGRITY, &(ESPExpr[0]));
    push_16(BP, EBP_INTEGRITY, &(EBPExpr[0]));
    push_16(SI, ESI_INTEGRITY, &(ESIExpr[0]));
    push_16(DI, EDI_INTEGRITY, &(EDIExpr[0]));
#endif
}

  void
BX_CPU_C::POPAD16(bxInstruction_c *i)
{
#if BX_CPU_LEVEL < 2
  BX_PANIC(("POPAD not supported on an 8086"));
#else /* 286+ */

    Bit16u di, si, bp, tmp, bx, dx, cx, ax;
    Bit8u di_integrity, si_integrity, bp_integrity, tmp_integrity, bx_integrity, dx_integrity, cx_integrity, ax_integrity;
  Expression *EAXExpr[2], *ECXExpr[2], *EDXExpr[2], *EBXExpr[2];
  Expression *ESPExpr[2], *EBPExpr[2], *ESIExpr[2], *EDIExpr[2];

    if (protected_mode()) {
      if ( !can_pop(16) ) {
        BX_PANIC(("pop_a: not enough bytes on stack"));
        exception(BX_SS_EXCEPTION, 0, 0);
        return;
        }
      }

    /* ??? optimize this */
    pop_16(&di, &di_integrity, &(EAXExpr[0]));
    pop_16(&si, &si_integrity, &(EAXExpr[0]));
    pop_16(&bp, &bp_integrity, &(EAXExpr[0]));
    pop_16(&tmp, &tmp_integrity, &(EAXExpr[0])); /* value for SP discarded */
    pop_16(&bx, &bx_integrity, &(EAXExpr[0]));
    pop_16(&dx, &dx_integrity, &(EAXExpr[0]));
    pop_16(&cx, &cx_integrity, &(EAXExpr[0]));
    pop_16(&ax, &ax_integrity, &(EAXExpr[0]));

    DI = di;
    SI = si;
    BP = bp;
    BX = bx;
    DX = dx;
    CX = cx;
    AX = ax;

    LVAL_EDI_INTEGRITY = di_integrity;
    LVAL_ESI_INTEGRITY = si_integrity;
    LVAL_EBP_INTEGRITY = bp_integrity;
    LVAL_EBX_INTEGRITY = bx_integrity;
    LVAL_EDX_INTEGRITY = dx_integrity;
    LVAL_ECX_INTEGRITY = cx_integrity;
    //LVAL_EAX_INTEGRITY = ax_integrity;
    BX_WRITE_32BIT_REG_INTEGRITY(0, ax_integrity);

#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
	TheLabels.WriteSymbolicRegister(0, 0, MakeACopyOf(EAXExpr[0]));
	TheLabels.WriteSymbolicRegister(0, 1, MakeACopyOf(EAXExpr[1]));
	TheLabels.WriteSymbolicRegister(1, 0, MakeACopyOf(ECXExpr[0]));
	TheLabels.WriteSymbolicRegister(1, 1, MakeACopyOf(ECXExpr[1]));
	TheLabels.WriteSymbolicRegister(2, 0, MakeACopyOf(EDXExpr[0]));
	TheLabels.WriteSymbolicRegister(2, 1, MakeACopyOf(EDXExpr[1]));
	TheLabels.WriteSymbolicRegister(3, 0, MakeACopyOf(EBXExpr[0]));
	TheLabels.WriteSymbolicRegister(3, 1, MakeACopyOf(EBXExpr[1]));
	TheLabels.WriteSymbolicRegister(4, 0, MakeACopyOf(ESPExpr[0]));
	TheLabels.WriteSymbolicRegister(4, 1, MakeACopyOf(ESPExpr[1]));
	TheLabels.WriteSymbolicRegister(5, 0, MakeACopyOf(EBPExpr[0]));
	TheLabels.WriteSymbolicRegister(5, 1, MakeACopyOf(EBPExpr[1]));
	TheLabels.WriteSymbolicRegister(6, 0, MakeACopyOf(ESIExpr[0]));
	TheLabels.WriteSymbolicRegister(6, 1, MakeACopyOf(ESIExpr[1]));
	TheLabels.WriteSymbolicRegister(7, 0, MakeACopyOf(EDIExpr[0]));
	TheLabels.WriteSymbolicRegister(7, 1, MakeACopyOf(EDIExpr[1]));
  }
#endif

#endif
}

  void
BX_CPU_C::PUSH_Iw(bxInstruction_c *i)
{
#if BX_CPU_LEVEL < 2
  BX_PANIC(("PUSH_Iv: not supported on 8086!"));
#else

    Bit16u imm16;
    Expression *NullExpr[2] = {NULL, NULL};

    imm16 = i->Iw();

    push_16(imm16, 0xFF, &(NullExpr[0]));
#endif
}

  void
BX_CPU_C::PUSH_Ew(bxInstruction_c *i)
{
    Bit16u op1_16;
  Bit8u op1_integrity;
  Expression *Op1Expr[2];

    /* op1_16 is a register or memory reference */
    if (i->modC0()) {
      op1_16 = BX_READ_16BIT_REG(i->rm());
      op1_integrity = BX_READ_16BIT_INTEGRITY(i->rm());
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
	Op1Expr[0] = MakeACopyOf(TheLabels.ReadSymbolicRegister(i->rm(), 0));
	Op1Expr[1] = MakeACopyOf(TheLabels.ReadSymbolicRegister(i->rm(), 1));
  }
#endif
      }
    else {
      /* pointer, segment address pair */
      read_virtual_word(i->seg(), RMAddr(i), &op1_16, &op1_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	read_virtual_expression(i->seg(), RMAddr(i), &(Op1Expr[0]));
  	read_virtual_expression(i->seg(), RMAddr(i) + 1, &(Op1Expr[1]));
  	Op1Expr[0] = MakeACopyOf(Op1Expr[0]);
  	Op1Expr[1] = MakeACopyOf(Op1Expr[1]);
  }
#endif
      }

    push_16(op1_16, op1_integrity, &(Op1Expr[0]));
}
